SystemOrganization addCategory: #'SMutant-Core'!
SystemOrganization addCategory: #'SMutant-Bank-Example'!

Object subclass: #BankAccount
	instanceVariableNames: 'balance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Bank-Example'!

!BankAccount class methodsFor: 'initialization' stamp: 'Milos 3/13/2011 19:20'!
balance: aBalance
	^super new balance: aBalance.! !

!BankAccount class methodsFor: 'instance creation' stamp: 'Milos 3/13/2011 19:22'!
new
	self error: 'use balance to create an object'.! !

!BankAccount methodsFor: 'accessing' stamp: 'Milos 3/13/2011 18:51'!
balance
	^balance.! !

!BankAccount methodsFor: 'private' stamp: 'Milos 3/13/2011 19:19'!
balance: aBalance
	balance := aBalance.! !

!BankAccount methodsFor: 'banking' stamp: 'Milos 3/13/2011 18:52'!
deposit: anAmount
	balance := balance + anAmount.! !

!BankAccount methodsFor: 'banking' stamp: 'Milos 3/13/2011 19:12'!
withdraw: anAmount
	balance >= anAmount
		ifTrue: [balance := balance - anAmount].! !

Object subclass: #SMutantObjects
	instanceVariableNames: 'objectsToMutate classesToMutate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Core'!

!SMutantObjects class methodsFor: 'initialize-release' stamp: 'Milos 3/14/2011 22:07'!
newSMutantObjects
	| sMutantObjects classesToMutate |
	sMutantObjects := super new.
	sMutantObjects objectsToMutate: OrderedCollection new.
	classesToMutate := OrderedCollection new.
	classesToMutate add: BankAccount.
	sMutantObjects classesToMutate: classesToMutate.
"	sMutantObjects classesToMutate: #(#BankAccount)."
	Smalltalk at: #GMutantObjects put: sMutantObjects.! !

!SMutantObjects methodsFor: 'collecting' stamp: 'Milos 3/14/2011 22:08'!
addObject: anObject
	(classesToMutate includes: anObject class)
		ifTrue: [objectsToMutate add: anObject].! !

!SMutantObjects methodsFor: 'accessing' stamp: 'Milos 3/14/2011 21:46'!
classesToMutate
	^classesToMutate.! !

!SMutantObjects methodsFor: 'accessing' stamp: 'Milos 3/14/2011 21:46'!
classesToMutate: aCollection
	classesToMutate := aCollection.! !

!SMutantObjects methodsFor: 'cleaning' stamp: 'Milos 3/13/2011 19:45'!
clear
	objectsToMutate clear.! !

!SMutantObjects methodsFor: 'accessing' stamp: 'Milos 3/13/2011 18:47'!
objectsToMutate
	^objectsToMutate.! !

!SMutantObjects methodsFor: 'accessing' stamp: 'Milos 3/13/2011 18:44'!
objectsToMutate: aCollection
	objectsToMutate := aCollection.! !

TestCase subclass: #BankAccountTest
	instanceVariableNames: 'bankAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMutant-Bank-Example'!

!BankAccountTest methodsFor: 'running' stamp: 'Milos 3/13/2011 19:24'!
setUp
	bankAccount := BankAccount balance: 50.! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 3/13/2011 19:24'!
testDeposit
	bankAccount deposit: 50.
	bankAccount deposit: 20.
	self assert: [bankAccount balance = 120].! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 3/13/2011 19:25'!
testWithdrawSuccessful
	bankAccount withdraw: 30.
	self assert: [bankAccount balance = 20].! !

!BankAccountTest methodsFor: 'tests' stamp: 'Milos 3/13/2011 19:25'!
testWithdrawUnsuccessful
	bankAccount withdraw: 70.
	self assert: [bankAccount balance = 50].! !
